#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <unistd.h>


typedef bool (*miniev_handler_t)(int fd, void* arg);
typedef void (*miniev_destructor_t)(void* arg);

typedef struct miniev_cb_t {
	void* arg;
	miniev_handler_t handler;
	miniev_destructor_t destructor;
} miniev_cb_t;

struct miniev_t;
typedef struct miniev_t miniev_t;

miniev_t* miniev_new(void);
void miniev_free(miniev_t* mev);

bool miniev_push(miniev_t* mev, int fd, miniev_cb_t cb);
int miniev_next(miniev_t* mev, int timeout_msec);

